#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <conio.h>
#include <ctype.h>
#include <windows.h>

typedef int (WINAPI *VeryPDF_PSToPDFFunc)(LPCTSTR lpCommand);
VeryPDF_PSToPDFFunc VeryPDF_PSToPDF = NULL;

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL ConvertPS2PDF(char *lpCmd)
{
	char path[_MAX_PATH];
	HINSTANCE hPS2PDF = NULL;
	BOOL bRet;
	GetModulePath(path,"ps2pdfsdk.dll");
	hPS2PDF = LoadLibrary(path);
	if(hPS2PDF == NULL)
		return FALSE;
	VeryPDF_PSToPDF=(VeryPDF_PSToPDFFunc)GetProcAddress(hPS2PDF,"VeryPDF_PSToPDF");
	if(VeryPDF_PSToPDF==NULL)
		return FALSE;
	bRet = VeryPDF_PSToPDF(lpCmd);
	FreeLibrary(hPS2PDF);
	return bRet;
}
void main(int argc, char *argv[])
{
	int i;
	char *lpLicenseKey = "XXXXXXXXXXXXXXXXXX";
	char szCommandLine[2048] = {0};
	int nRet = 0;

	if(argc < 2)
	{
		printf("test.exe C:\\test.ps\n");
		printf("test.exe C:\\test.ps C:\\test.pdf\n");
		return;
	}

	//sprintf(szCommandLine,"ps2pdf -mode 2 -$ \"%s\" ",lpLicenseKey);
	sprintf(szCommandLine,"ps2pdf -$ \"%s\" ",lpLicenseKey);
	for(i = 1; i < argc; i++)
	{
		strcat(szCommandLine, " \"");
		strcat(szCommandLine, argv[i]);
		strcat(szCommandLine, "\"");
	}
	if(1)
		nRet = ConvertPS2PDF(szCommandLine);
	else
	{
		char *lpszFiles[] = {
			"C:\\Test 2 Page.pdf",
			"C:\\Test 4 Page.pdf",
			"C:\\Test 6 Page.pdf"
		};
		for(i = 0; i < sizeof(lpszFiles)/sizeof(char*); i++)
		{
			sprintf(szCommandLine,"ps2pdf -$ \"%s\" -pdf2ps \"",lpLicenseKey);
			strcat(szCommandLine, lpszFiles[i]);
			strcat(szCommandLine, "\" \"");
			strcat(szCommandLine, lpszFiles[i]);
			strcat(szCommandLine, ".ps\"");
			nRet = ConvertPS2PDF(szCommandLine);
			printf("nRet = %d, %s\n", nRet, szCommandLine);
		}
	}
	printf("nRet = %d\n", nRet);
}